// Duplicat Bytes Search

#include "stdafx.h"
#include "CFileIO.h"

#ifndef _DEBUG 
#pragma comment(linker, "/nodefaultlib:LIBC.lib")
#pragma comment(linker, "/defaultlib:MSVCRT.LIB")
#pragma comment(linker, "/OPT:NOWIN98")
#endif

CAnsiString Str(DWORD val);

int main(int argc, char* argv[])
{
	CFileIO File1,File2;
	
	
	if (argc != 4)
	{
		printf("Error Wrong Parameter List.\n");
		printf("dbs File1 File2 OutName.\n");
		printf("dbs d:\\a.bin d:\\b.bin d:\\outdir\\binab \n");
		return 0;
	}

	CAnsiString fa,fb;
	fa.SetString(argv[1]);
	fb.SetString(argv[2]);
	
	if (!File1.OpenReadOnly(fa))
	{
		printf("Error Opening File1.\n");
		return 0;
	}
	if (!File2.OpenReadOnly(fb))
	{
		printf("Error Opening File2.\n");
		return 0;
	}
	
	
	DWORD dwF1 = File1.GetFileSize();
	DWORD dwF2 = File2.GetFileSize();
	CBuffer a,b;
	if (!a.SetBufferSize(File1.GetFileSize()) )
	{
		printf("Error Low Memory.1\n");
		return 0;
	}
	if (	!b.SetBufferSize(File2.GetFileSize()))
	{
		printf("Error Low Memory.2\n");
		return 0;
	}
	if ( ! File2.ReadFile(b))
	{
		printf("Error Reading File.2\n");
		return 0;
	}
	if (! File1.ReadFile(a)  )
	{
		printf("Error Reading File.1\n");
		return 0;
	}
	File1.CloseFile();
	File2.CloseFile();
	
	DWORD dwix;
	char c1,c2;
	
	BOOL bEqual;
	DWORD dwStartLoc;
	DWORD dwDataSize;
	
	printf("Starting Reading File( %lu = %lu(%lu),%lu = %lu(%lu) ).\n",dwF1,a.GetDataSize(),a.GetBufferSize(),dwF2,b.GetDataSize(),b.GetBufferSize());

	DWORD dwEqualCount = 0;
	for (DWORD i = 0; i < dwF1;i++)
	{
		
		dwix = i;
		bEqual = FALSE;
		dwStartLoc = i;
		
		//	printf("Check Next Char.1(%lu)\n",i);
		for (DWORD i2 = 0;i2 < dwF2;i2++)
		{
			c1 = a[dwix];
			//printf("Check Next Char.1(%lu)\n",i);
			c2 = b[i2];
			//printf("Check Next Char.2(%lu)\n",i2);
			if (c1 == c2)
			{
				//	printf("Find Equal Data.\n");
				
				if(bEqual)
				{
					dwDataSize++;
					dwix++;
				}
				else
				{
					bEqual = TRUE;
					dwStartLoc = i;
					dwDataSize = 1;
					dwix++;
				}
				if (dwix == dwF1 && bEqual)
				{
			
						
						if (dwDataSize > 10)
						{
							CAnsiString OutFileName,s;
							OutFileName.SetString(argv[3]);
							dwEqualCount++;
							OutFileName += Str("_");
							s = Str(dwEqualCount);
							if (dwEqualCount < 10)
								s = Str("0") + s;
							if (dwEqualCount < 100)
								s = Str("0") + s;
							if (dwEqualCount < 1000)
								s =Str("0") + s;
							if (dwEqualCount < 10000)
								s = Str("0") + s;
							
							OutFileName += s;
							OutFileName += Str(".dbs");
							
							printf("Writing Equal Data(%s). Loc = %lu, Size  %lu\n",OutFileName.GetPtr(),dwStartLoc,dwDataSize);
							CFileIO OutFile;
							if (	!OutFile.CreateNewFile(OutFileName))
							{
								printf("Error While Creating %s\n",OutFileName.GetPtr());
								return 0;
							}
							if (!OutFile.WriteFile(&a[dwStartLoc],dwDataSize))
							{
								printf("Error While Writing To \"%s\".\n",OutFileName.GetPtr());
								
								return 0;
							}
							OutFile.CloseFile();
						}
						bEqual = FALSE;
						i += dwDataSize;
						break;
				}
			}
			else
			{
				if(bEqual)
				{
					
					if (dwDataSize > 5)
					{
						CAnsiString OutFileName,s;
						OutFileName.SetString(argv[3]);
						dwEqualCount++;
						OutFileName += Str("_");
						s = Str(dwEqualCount);
						if (dwEqualCount < 10)
							s = Str("0") + s;
						if (dwEqualCount < 100)
							s = Str("0") + s;
						if (dwEqualCount < 1000)
							s =Str("0") + s;
						if (dwEqualCount < 10000)
							s = Str("0") + s;
						
						OutFileName += s;
						OutFileName += Str(".dbs");
						
						printf("Writing Equal Data(%s). Loc = %lu, Size  %lu\n",OutFileName.GetPtr(),dwStartLoc,dwDataSize);
						CFileIO OutFile;
						if (	!OutFile.CreateNewFile(OutFileName))
						{
							printf("Error While Creating %s\n",OutFileName.GetPtr());
							return 0;
						}
						if (!OutFile.WriteFile(&a[dwStartLoc],dwDataSize))
						{
							printf("Error While Writing To \"%s\".\n",OutFileName.GetPtr());
							
							return 0;
						}
						OutFile.CloseFile();
					}
					bEqual = FALSE;
					i += dwDataSize;
					i--;
			
					break;
				}
				else
				{
					dwDataSize = 0;
					bEqual = FALSE;
					dwix = i;
					
				}
			}
			
			}
		}
		
		
		
		return 0;
}

CAnsiString Str(DWORD val)
{
	char buff[64];
	_snprintf(buff,64,"%lu",val);
	
	CAnsiString astr;
	
	astr.SetString(buff);
	
	return astr.ReturnFinal();
}
